<!-- This is a bug report template. By following the instructions below and filling out the sections with your information, you will help the developers get all the necessary data to fix your issue.
You can also preview your report before submitting it. You may remove sections that aren't relevant to your particular case.

Before we begin, please note that this tracker is only for issues. It is not for questions, comments, or feature requests.

If you would like to discuss a new feature or submit suggestions, please visit the community forum:
https://community.signalusers.org

If you are looking for support, please visit our support center:
https://support.signal.org/
or email support@signal.org

Let's begin with a checklist: Replace the empty checkboxes [ ] below with checked ones [x] accordingly. -->

- [ ] I have searched open and closed issues for duplicates
- [ ] I am submitting a bug report for existing functionality that does not work as intended
- [ ] This isn't a feature request or a discussion topic

----------------------------------------

### Bug description
Describe here the issue that you are experiencing.

### Steps to reproduce
- using hyphens as bullet points
- list the steps
- that reproduce the bug

**Actual result:** Describe here what happens after you run the steps above (i.e. the buggy behaviour)

**Expected result:** Describe here what should happen after you run the steps above (i.e. what would be the correct behaviour)

### Screenshots
<!-- you can drag and drop images below -->


### Device info
<!-- replace the examples with your info -->
**Device**: iDevice X

**iOS version**: X.Y.Z

**Signal version:** Z.Y

### Link to debug log
<!-- Ensure that "Enable Debug Log" is on in Signal's settings then make the bug happen and immediately after that tap "Submit Debug Log" from settings and paste the link below. -->

<!--  If this is a crashing bug, after filing this issue, email a copy of your latest crash report to support@whispersystems.org

To get a crash log:

1. Go to the iOS Settings app.
2. Go to Privacy.
3. Go to Analytics or Diagnostics & Usage.
4. Select Analytics Data or Diagnostics & Usage Data.
5. Locate the .ips crash log for Signal.
    The logs will be named in the format: Signal(DateTime).ips
6. Select the desired Signal log.
7.a iOS 11 users, tap the Share icon in the top right corner and jump to step 10.
7.b iOS 9&10 users, long press to see the option to highlight text and select the entire text of the log. It will end in EOF.
8. Once the text is selected, tap Copy.
9. Paste the copied text into an email.
10. Send the email to support@signal.org with a subject like:
  * "iOS Crash Log: (your github issue)"
  * Example subject: iOS Crash Log: Crash on launch #111
  * Example subject: iOS Crash Log: Crash when sending video #222
-->
